All of lore.kernel.org
 help / color / mirror / Atom feed
From: Chandan Babu R <chandanrlinux@gmail.com>
To: fstests@vger.kernel.org
Cc: Chandan Babu R <chandanrlinux@gmail.com>,
	linux-xfs@vger.kernel.org, djwong@kernel.org
Subject: [PATCH V5 11/13] xfs: Check for extent overflow when remapping an extent
Date: Mon,  8 Mar 2021 21:21:09 +0530	[thread overview]
Message-ID: <20210308155111.53874-12-chandanrlinux@gmail.com> (raw)
In-Reply-To: <20210308155111.53874-1-chandanrlinux@gmail.com>

This test verifies that XFS does not cause inode fork's extent count to
overflow when remapping extents from one file's inode fork to another.

Signed-off-by: Chandan Babu R <chandanrlinux@gmail.com>
---
 tests/xfs/535     | 81 +++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/535.out |  8 +++++
 tests/xfs/group   |  1 +
 3 files changed, 90 insertions(+)
 create mode 100755 tests/xfs/535
 create mode 100644 tests/xfs/535.out

diff --git a/tests/xfs/535 b/tests/xfs/535
new file mode 100755
index 00000000..6bb27c92
--- /dev/null
+++ b/tests/xfs/535
@@ -0,0 +1,81 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2021 Chandan Babu R.  All Rights Reserved.
+#
+# FS QA Test 535
+#
+# Verify that XFS does not cause inode fork's extent count to overflow when
+# remapping extents from one file's inode fork to another.
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/reflink
+. ./common/inject
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs xfs
+_require_scratch
+_require_scratch_reflink
+_require_xfs_debug
+_require_xfs_io_command "reflink"
+_require_xfs_io_error_injection "reduce_max_iextents"
+
+echo "* Reflink remap extents"
+
+echo "Format and mount fs"
+_scratch_mkfs >> $seqres.full
+_scratch_mount >> $seqres.full
+
+bsize=$(_get_block_size $SCRATCH_MNT)
+
+srcfile=${SCRATCH_MNT}/srcfile
+dstfile=${SCRATCH_MNT}/dstfile
+
+nr_blks=15
+
+echo "Create \$srcfile having an extent of length $nr_blks blocks"
+$XFS_IO_PROG -f -c "pwrite -b $((nr_blks * bsize))  0 $((nr_blks * bsize))" \
+       -c fsync $srcfile >> $seqres.full
+
+echo "Create \$dstfile having an extent of length $nr_blks blocks"
+$XFS_IO_PROG -f -c "pwrite -b $((nr_blks * bsize))  0 $((nr_blks * bsize))" \
+       -c fsync $dstfile >> $seqres.full
+
+echo "Inject reduce_max_iextents error tag"
+_scratch_inject_error reduce_max_iextents 1
+
+echo "Reflink every other block from \$srcfile into \$dstfile"
+for i in $(seq 1 2 $((nr_blks - 1))); do
+	_reflink_range $srcfile $((i * bsize)) $dstfile $((i * bsize)) $bsize \
+		       >> $seqres.full 2>&1
+done
+
+echo "Verify \$dstfile's extent count"
+nextents=$(xfs_get_fsxattr nextents $dstfile)
+if (( $nextents > 10 )); then
+	echo "Extent count overflow check failed: nextents = $nextents"
+	exit 1
+fi
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/535.out b/tests/xfs/535.out
new file mode 100644
index 00000000..cfe50f45
--- /dev/null
+++ b/tests/xfs/535.out
@@ -0,0 +1,8 @@
+QA output created by 535
+* Reflink remap extents
+Format and mount fs
+Create $srcfile having an extent of length 15 blocks
+Create $dstfile having an extent of length 15 blocks
+Inject reduce_max_iextents error tag
+Reflink every other block from $srcfile into $dstfile
+Verify $dstfile's extent count
diff --git a/tests/xfs/group b/tests/xfs/group
index b4f0c777..aed06494 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -532,3 +532,4 @@
 532 auto quick dir hardlink symlink
 533 auto quick
 534 auto quick reflink
+535 auto quick reflink
-- 
2.29.2


  parent reply	other threads:[~2021-03-08 15:52 UTC|newest]

Thread overview: 23+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-03-08 15:50 [PATCH V5 00/13] xfs: Tests to verify inode fork extent count overflow detection Chandan Babu R
2021-03-08 15:50 ` [PATCH V5 01/13] _check_xfs_filesystem: sync fs before running scrub Chandan Babu R
2021-03-08 17:50   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 02/13] common/xfs: Add a helper to get an inode fork's extent count Chandan Babu R
2021-03-08 17:52   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 03/13] common/xfs: Add helper to obtain fsxattr field value Chandan Babu R
2021-03-08 17:53   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 04/13] xfs: Check for extent overflow when trivally adding a new extent Chandan Babu R
2021-03-08 18:08   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 05/13] xfs: Check for extent overflow when growing realtime bitmap/summary inodes Chandan Babu R
2021-03-08 18:10   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 06/13] xfs: Check for extent overflow when punching a hole Chandan Babu R
2021-03-08 15:51 ` [PATCH V5 07/13] xfs: Check for extent overflow when adding/removing xattrs Chandan Babu R
2021-03-08 15:51 ` [PATCH V5 08/13] xfs: Check for extent overflow when adding/removing dir entries Chandan Babu R
2021-03-08 18:15   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 09/13] xfs: Check for extent overflow when writing to unwritten extent Chandan Babu R
2021-03-08 18:16   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 10/13] xfs: Check for extent overflow when moving extent from cow to data fork Chandan Babu R
2021-03-08 18:18   ` Darrick J. Wong
2021-03-08 15:51 ` Chandan Babu R [this message]
2021-03-08 18:19   ` [PATCH V5 11/13] xfs: Check for extent overflow when remapping an extent Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 12/13] xfs: Check for extent overflow when swapping extents Chandan Babu R
2021-03-08 15:51 ` [PATCH V5 13/13] xfs: Stress test with bmap_alloc_minlen_extent error tag enabled Chandan Babu R

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20210308155111.53874-12-chandanrlinux@gmail.com \
    --to=chandanrlinux@gmail.com \
    --cc=djwong@kernel.org \
    --cc=fstests@vger.kernel.org \
    --cc=linux-xfs@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.